'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _v = require('uuid/v4');

var _v2 = _interopRequireDefault(_v);

require('./styles/style.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SnackBar = function (_React$Component) {
    _inherits(SnackBar, _React$Component);

    function SnackBar(props) {
        _classCallCheck(this, SnackBar);

        var _this = _possibleConstructorReturn(this, (SnackBar.__proto__ || Object.getPrototypeOf(SnackBar)).call(this, props));

        _this.state = {
            notifications: [],
            options: {
                positionY: 'bottom',
                positionX: 'right',
                fadeout: 15,
                dummyDisplay: false
            }
        };
        return _this;
    }

    _createClass(SnackBar, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var notifications = this.state.notifications;
            var newItems = this.props.notifications && this.props.notifications.length > 0 && this.props.notifications.map(function (ni) {
                ni.timestamp = new Date().getTime();
                ni.key = (0, _v2.default)();
                return ni;
            });

            var options = this.state.options;
            if (this.props.options && Object.keys(this.props.options).length > 0) {
                var newOptions = this.props.options;
                Object.keys(newOptions).map(function (key) {
                    options[key] = newOptions[key];
                });
            }

            this.setState({
                notifications: notifications.concat(newItems),
                options: options
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps, nextContext) {
            var notifications = this.state.notifications;
            var newItems = nextProps.notifications.map(function (ni) {
                ni.timestamp = new Date().getTime();
                ni.key = (0, _v2.default)();
                return ni;
            });
            notifications.concat(newItems);
            this.setState({
                notifications: notifications
            });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.state.options.dummyDisplay) this.dummyNotifications();
            this.cleaner();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            if (this.state.notifications.length <= 0) return _react2.default.createElement(_react2.default.Fragment, null);

            var style = {};
            if (this.state.options.positionY === 'top') {
                style.top = '15px';
            } else {
                style.bottom = '15px';
            }
            if (this.state.options.positionX === 'left') {
                style.left = '20px';
            } else {
                style.right = '20px';
            }

            return _react2.default.createElement(
                'div',
                { id: 'reactSnackBar', className: 'snackBarContainer', style: style },
                this.state.notifications.map(function (item) {
                    return _this2.showItem(item);
                })
            );
        }
    }, {
        key: 'redirectTo',
        value: function redirectTo(e, target) {
            window.location.href = target;
            this.closeItem(e);
        }
    }, {
        key: 'closeItem',
        value: function closeItem(e) {
            var idx = e.target.getAttribute('data-key');
            var notifications = this.state.notifications.filter(function (i) {
                return i.key !== idx;
            });
            this.setState({ notifications: notifications });
        }
    }, {
        key: 'showItem',
        value: function showItem(item) {
            var _this3 = this;

            return _react2.default.createElement(
                'div',
                { key: (0, _v2.default)(), className: 'snackBarItem' },
                _react2.default.createElement(
                    'div',
                    { className: 'messageBox' },
                    _react2.default.createElement(
                        'p',
                        null,
                        item.message
                    )
                ),
                _react2.default.createElement(
                    'div',
                    { className: 'actionBox' },
                    item.action.map(function (a) {
                        if ("link" in a) return _react2.default.createElement(
                            'button',
                            { key: (0, _v2.default)(),
                                onClick: function onClick(e) {
                                    return _this3.redirectTo(e, a.link);
                                } },
                            a.label
                        );else return _react2.default.createElement(
                            'button',
                            { key: (0, _v2.default)(), 'data-key': item.key,
                                onClick: function onClick(e) {
                                    return _this3.closeItem(e);
                                } },
                            a.label
                        );
                    })
                )
            );
        }
    }, {
        key: 'cleaner',
        value: function cleaner() {
            setInterval(function () {
                var _this4 = this;

                var notifications = this.state.notifications;
                var nowTime = new Date().getTime();
                notifications = notifications.filter(function (item) {
                    return (nowTime - item.timestamp) / 1000 < _this4.state.options.fadeout;
                });
                this.setState({ notifications: notifications });
            }.bind(this), 1000);
        }
    }, {
        key: 'dummyNotifications',
        value: function dummyNotifications() {
            var counter = 1;
            setInterval(function () {
                var notifications = this.state.notifications;
                if (notifications.length >= 10) notifications.shift();
                notifications.push({
                    timestamp: new Date().getTime(),
                    key: (0, _v2.default)(),
                    message: 'Process ' + counter++ + ' Completed ',
                    action: [{
                        label: 'OK'
                    }]
                });
                this.setState({ notifications: notifications });
            }.bind(this), 5000);
        }
    }]);

    return SnackBar;
}(_react2.default.Component);

exports.default = SnackBar;